--ver: 3.25r
---AddFriend is a reserved command by Blizzard, so to prevent conflicts using AFriend
AFriend = LibStub("AceAddon-3.0"):NewAddon("AFriend", "AceHook-3.0");

local Afriends = LibStub("LibFriends-1.0");
local Aguilds = LibStub("LibGuild-1.0");
local AFriend = AFriend;
local AButtons = {}
local ATargets = {}
local AButtonTxt = {}
local AFriendButtons = {}
local AfriendMenu = {}

AButtons = {"Add_Friend", "Remove_Friend", "Add_Guild", "Remove_Guild"}
AButtonTxt = {"Add Friend", "Remove Friend", "Invite to Guild", "Remove from Guild"}
AToolTips = {"Add player to your friends list", "Remove player from your friends list", "Invite this player to join your guild", "Remove this player from your guild"}
local redColor = {r=1.0, g=0, b=0};
local greenColor = {r = 0, g = 1.0, b = 0};
AColors = {greenColor, redColor, greenColor, redColor}

function AFriend:OnInitialize()
	local versionString = GetAddOnMetadata("AddFriend", "Version");
end

function AFriend:OnEnable()
	for i,v in ipairs(AButtons) do
		AFriendButtons[v] = { text = format("%s", AButtonTxt[i]), dist = 0, color = AColors[i], tooltipText = AToolTips[i] };
		AfriendMenu[i] = v;
	end
	self:SecureHook("UnitPopup_ShowMenu");
end

function AFriend:OnDisable()
	self:Unhook("UnitPopup_ShowMenu");
end

function AFriend:UnitPopup_ShowMenu(dropdownMenu, which, unit, name, userData)
	local thisName = name or UnitName(unit)
	which = string.gsub(which, "PB4_", "")
	if which == "PET" or which == "SELF" then 
		return;
	elseif which ~= "FRIEND" and which ~= "PLAYER" and which ~= "PARTY" and which ~= "RAID_PLAYER" and which ~= "RAID" then 
		return;
	end
	if (which ~= "FRIEND") and (not UnitCanCooperate("player", unit) or UnitGUID(unit) == UnitGUID("player"))  then 
		return;
	end
	if (UIDROPDOWNMENU_MENU_LEVEL > 1) then
		return;
	end
	
	local info = UIDropDownMenu_CreateInfo();
	for index, value in ipairs(AfriendMenu) do
		info.text = AFriendButtons[value].text;
		info.value = value;
		info.owner = which;
		info.func = AFriend_Button_Onclick;
		info.notCheckable = 1;
		color = AFriendButtons[value].color;
		if color then
			info.colorCode = string.format("|cFF%02x%02x%02x", color.r*255, color.g*255, color.b*255);
		else
			info.colorCode = nil;
		end		
		info.arg1 = {["button"] = value, ["unit"] = unit, ["name"] = name};
		info.tooltipTitle = AFriendButtons[value].text;
		info.tooltipText = AFriendButtons[value].tooltipText;
		if IsInGuild() and CanGuildInvite() then
			if value == "Remove_Guild" and Aguilds:HasMember(thisName) ~= nil then
				UIDropDownMenu_AddButton(info);
			end
			if value == "Add_Guild" and Aguilds:HasMember(thisName) == nil then
				UIDropDownMenu_AddButton(info);
			end
		end
		if value == "Remove_Friend" and Afriends:HasFriend(thisName) then
			UIDropDownMenu_AddButton(info);
		end
		if value == "Add_Friend" and not Afriends:HasFriend(thisName) then
			UIDropDownMenu_AddButton(info);
		end
	end
end

function AFriend_Button_Onclick(self, info)
	assert(info);
	button = info.button;
	assert(button);
	name = info.name or UnitName(info.unit);
	assert(name);
	if button == "Add_Friend" then
		AddFriend(name);
	elseif button == "Remove_Friend" then
		RemoveFriend(name);
	elseif button == "Add_Guild" then
		GuildInvite(name);
	elseif button == "Remove_Guild" then
		GuildUninvite(name);
	end
end